--apparently this makes shit faster? wtf?
local TICRATE = TICRATE
local FRACUNIT = FRACUNIT
local MAXSKINCOLORS = MAXSKINCOLORS
local ANG1 = ANG1
local k_sneakertimer = k_sneakertimer
local k_spinouttimer = k_spinouttimer
local k_wipeoutslow = k_wipeoutslow
local k_driftboost = k_driftboost
local k_floorboost = k_floorboost
local k_startboost = k_startboost
local k_itemamount = k_itemamount
local k_itemtype = k_itemtype
local k_rocketsneakertimer = k_rocketsneakertimer
local k_hyudorotimer = k_hyudorotimer
local k_drift = k_drift
local k_speedboost = k_speedboost
local k_accelboost = k_accelboost
local k_invincibilitytimer = k_invincibilitytimer
local k_growshrinktimer = k_growshrinktimer
local k_throwdir = k_throwdir

--item flags
local XIF_POWERITEM = 1 --is power item (affects final odds)
local XIF_COOLDOWNONSTART = 2 --can't be obtained on start cooldown
local XIF_UNIQUE = 4 --only one can exist in anyone's slot
local XIF_LOCKONUSE = 8 --locks the item slot when the item is used, slot must be unlocked manually by setting player.xItemData.xItem_itemSlotLocked to false
local XIF_COOLDOWNINDIRECT = 16 --checks if indirectitemcooldown is 0
local XIF_COLPATCH2PLAYER = 32 --map hud patch colour to player prefcolor
local XIF_ICONFORAMT = 64 --item icon changes depending on the item amount (animation frames become amount frames)

freeslot("SPR_TAKO","sfx_putput")

local inkself = CV_RegisterVar({name = "takkon_inkself", defaultvalue = "No", flags = CV_NETVAR, PossibleValue = CV_YesNo})
local takkon = {max_timer = 20 * TICRATE, 
				sneaker_cooldown = 5 * TICRATE,
				move = false, 
				start_x = -512,
				x = -512,
				color = 0,
				player_ink = {}
}

-- From LJ Sonik's PRNG library
local tk_prng_t = 0
local tk_prng_x = 6278
local tk_prng_y = 975
local tk_prng_z = 39207
local tk_prng_w = 45678
local function TK_Random()
	tk_prng_t = tk_prng_x ^^ (tk_prng_x << 11)
	tk_prng_x, tk_prng_y, tk_prng_z, tk_prng_w = tk_prng_y, tk_prng_z, tk_prng_w, tk_prng_w ^^ (tk_prng_w >> 19) ^^ tk_prng_t ^^ (tk_prng_t >> 8) -- What the fuck?
	return tk_prng_w
end
local function TK_RandomKey(n)
    return abs(TK_Random() % n)
end
local function TK_RandomRange(a, b)
    return a + abs(TK_Random() % (b - a + 1))
end


addHook("NetVars", function(net)
	takkon = net($)
end)

addHook("ThinkFrame", function()
	if takkon.move == true then
		takkon.x  = $ + 4
    end
    
    if takkon.x > 512 then
        takkon.move = false
    end
end)

local function useTakkon(p, cmd)
	p.kartstuff[k_itemamount] = $ - 1
	takkon.x = takkon.start_x
	takkon.move = true
	takkon.color = p.skincolor
	if hitfeed then
		local s = {{p.name, p.mo.hf_overridenamecolor or p.skincolor}, {skins[p.mo.skin].facemmap, p.skincolor}, p}
		local v
		local icon = "HF_TAKON"
			
		HF_SendHitMessage(s, v, icon)
	end
	for q in players.iterate do
		if q.kartstuff[k_position] < (p.kartstuff[k_position] + inkself.value) then
			if takkon.player_ink[#q].timer == 0 or takkon.player_ink[#q].timer == nil then
				takkon.player_ink[#q].timer = takkon.max_timer
				--Generating Random Spots
				takkon.player_ink[#q].spots = $ or {}
				for i = 1, TK_RandomRange(8,12) do
					takkon.player_ink[#q].spots[i] = {
						x = TK_RandomRange(0, 40) * 4,
						y = TK_RandomRange(6, 20) * 4,
						--X and Y are multiplied by 2 in full screen, and are left alone in splitscreen
						scale = TK_RandomRange(4,6) * (FRACUNIT / 8),
						trans_flag = 0,
						cur_y = 8,
						patch = TK_RandomRange(1,8)
					}
				end
			end
		end
	end
	
	if not p.kartstuff[k_itemamount] and not inkself.value then
		p.kartstuff[k_itemamount] = 1
		p.kartstuff[k_itemtype] = KITEM_SNEAKER
		p.kartstuff[k_itemblink] = 6
		p.kartstuff[k_itemblinkmode] = 0
	end

	K_SetIndirectItemCooldown(20*TICRATE)
end

local function TakkonOdds(newodds, pos, mashed, rush, p, secondist, pingame, pexiting)
	local takkon_odds = newodds
	for player in players.iterate do
		if (takkon.player_ink[#player] and takkon.player_ink[#player].timer > 0) then
			takkon_odds = 0
		end
	end
	
	return takkon_odds
end

addHook("PlayerThink", function(player)
	if takkon.player_ink[#player] != nil then
		takkon.player_ink[#player].timer = $ or 0
		takkon.player_ink[#player].timer = max($ - 1, 0)
		takkon.player_ink[#player].ind_x = takkon.x + (4 / (splitscreen + 1))
	else
		takkon.player_ink[#player] = {timer = 0, spots = {}, ind_x = -512}
	end
	
	if leveltime == 0 then
		takkon.player_ink[#player].timer = 0
	end
	if not (player.mo and player.mo.valid) then return end
	
	if takkon.player_ink[#player].timer > 0 then
		if takkon.x >= 160 then
			player.mo.colorized = true
			if player.speed >= K_GetKartSpeed(player) / 2 and player.kartstuff[k_boostpower] >= 0 then
				player.mo.friction = 31 * FRACUNIT / 32
			end
			
		end
		
		if takkon.x > -128 and takkon.x < (320 + 128) and not S_IdPlaying(sfx_putput) then
			S_StartSoundAtVolume(nil,sfx_putput, 255 , player)
		end
	end 
	
	if takkon.player_ink[#player].timer < 18 and takkon.player_ink[#player].spots then
		for key, value in ipairs(takkon.player_ink[#player].spots) do
			value.trans_flag = V_10TRANS * (10 - (takkon.player_ink[#player].timer / 2))
		end
	end

	if (player.kartstuff[k_sneakertimer] > 0 and not player.trickboost) or --If Sneaker (Not Trickboost)
		player.kartstuff[k_hyudorotimer] > 0 or player.kartstuff[k_growshrinktimer] > 0 or --If In Hyu or Grow
		player.kartstuff[k_invincibilitytimer] > 0 or player.kartstuff[k_respawn] > 0 or  --If In Inv or Respawning
		(player.mo.eflags & MFE_UNDERWATER and not player.takkon_water_check) or  --If Entering Water (Only When Entering)
		player.exiting then --When Done with the Race
			if takkon.player_ink[#player].timer < (takkon.max_timer - takkon.sneaker_cooldown) then
				takkon.player_ink[#player].timer = min($, 20)
			end
	end
	
	if takkon.player_ink[#player].timer == 0 then
		takkon.player_ink[#player].spots = {}
	end
	
	player.takkon_water_check = player.mo.eflags & MFE_UNDERWATER
end)

local function TakkonHud(v,p,c)
    local drawn_ink_splotches = {}
    for player in displayplayers.iterate() do
        if takkon.player_ink[#player] and takkon.player_ink[#player].spots then
            for key, value in ipairs(takkon.player_ink[#player].spots) do
                local spot = {}
                spot.x = value.x
                spot.y = value.y
                spot.scale = value.scale
                spot.color = player.skincolor
                spot.trans_flag = value.trans_flag
                spot.patch = value.patch
                spot.cur_y = value.cur_y
                --Splitscreen Shenanigans
                if splitscreen <= 1 then
                    spot.x = $ * 2
                    if splitscreen == 0 then
                        spot.y = $ * 2
                    else
                        spot.y = $ + (player.splitscreenindex * 100)
                    end
                    spot.scale = value.scale * 2
                elseif splitscreen >= 2 then
                    spot.x = $ + ((player.splitscreenindex % 2) * 160)
                    spot.y = $ + ((player.splitscreenindex / 2) * 100)
                end
                
                if takkon.player_ink[#player].ind_x > spot.x and spot.cur_y < spot.y then
                    value.cur_y = $ + 4
                end
                
                table.insert(drawn_ink_splotches, spot)
            end
			if takkon.player_ink[#player].timer > 0
				v.drawScaled(takkon.player_ink[#player].ind_x * FRACUNIT, 16 * FRACUNIT, FRACUNIT, v.cachePatch("GAM_TAKN"), nil, v.getColormap(TC_DEFAULT, takkon.color))
			end
        end
    end
    
    for key, value in ipairs(drawn_ink_splotches)
        if takkon.x >= value.x then
            if value.cur_y < value.y then
                v.drawScaled(value.x * FRACUNIT, value.cur_y * FRACUNIT, value.scale, v.cachePatch("BLOPDROP"), value.trans_flag, v.getColormap(TC_DEFAULT, value.color))
            else
                v.drawScaled(value.x * FRACUNIT, value.y * FRACUNIT, value.scale, v.cachePatch("BLOP"..value.patch), value.trans_flag, v.getColormap(TC_DEFAULT, value.color))
            end
        end
    end
    
    
end

hud.add(TakkonHud, "game")
hud.add(TakkonHud, "scores")

if xItemLib then
	xItemLib.func.addItem{
		"XITEM_TAKKON", --Item Code
		"Takkon", --Item Name
		"K_ITTAKN", --Big Graphic Name
		"K_ISTAKN", --Small Graphic Name
		XIF_UNIQUE|XIF_POWERITEM|XIF_COOLDOWNONSTART|XIF_COOLDOWNINDIRECT, --Flags
		{0,0,0,0,1,1,0,0,0,0}, --Race Odds
		{0,0}, --Battle Odds
		nil, --Item Recieved Function
		useTakkon, --Item Used Function
		nil, --Item Hud Function (For Animation in the Hud, I think)
		TakkonOdds, --Item Odds Override
		nil, --Item Results Function
		{0, {SPR_TAKO, A}}, --Dropped Item Frames
		true, --Show Up in Roulette?
		nil, --Preuse Function
		nil --Dropped Item Function
	}
end