--apparently this makes shit faster? wtf?
local TICRATE = TICRATE
local FRACUNIT = FRACUNIT
local MAXSKINCOLORS = MAXSKINCOLORS
local ANG1 = ANG1
local k_sneakertimer = k_sneakertimer
local k_spinouttimer = k_spinouttimer
local k_wipeoutslow = k_wipeoutslow
local k_driftboost = k_driftboost
local k_floorboost = k_floorboost
local k_startboost = k_startboost
local k_itemamount = k_itemamount
local k_itemtype = k_itemtype
local k_rocketsneakertimer = k_rocketsneakertimer
local k_hyudorotimer = k_hyudorotimer
local k_drift = k_drift
local k_speedboost = k_speedboost
local k_accelboost = k_accelboost
local k_invincibilitytimer = k_invincibilitytimer
local k_growshrinktimer = k_growshrinktimer
local k_throwdir = k_throwdir


freeslot("SPR_ABJZ","SPR_AJRT","MT_AFTERBURNER_JAWZ", "MT_ABJZBOOSTER", "S_AFTERBURNERJAWZ_A","S_AFTERBURNERJAWZ_B")
local invincible = CV_RegisterVar({
	name = "afterburner_targetinvincible",
	defaultvalue = "No",
	flags = CV_NETVAR,
	PossibleValue = CV_YesNo
})

mobjinfo[MT_AFTERBURNER_JAWZ] = {
	doomednum = -1,
	spawnstate = S_AFTERBURNERJAWZ_A,
	spawnhealth = 1,
	seestate = S_NULL,
	seesound = sfx_tossed,
	reactiontime = 8,
	attacksound = sfx_None,
	painstate = S_NULL,
	painchance = 0,
	painsound = sfx_None,
	meleestate = S_NULL,
	missilestate = S_NULL,
	deathstate = S_NULL,
	xdeathstate = S_NULL,
	deathsound = sfx_s3k5d,
	speed = 0,
	radius = 20*FRACUNIT,
	height = 16*FRACUNIT,
	dispoffset = 0,
	mass = 0,
	damage = 0,
	activesound = sfx_s3kc0s,
	flags = MF_NOGRAVITY|MF_NOCLIPHEIGHT|MF_NOCLIPTHING|MF_DONTENCOREMAP,
	raisestate = S_NULL
}

mobjinfo[MT_ABJZBOOSTER] = {
		doomednum = -1,
		spawnstate = S_BOOSTFLAME,
		spawnhealth = 1000,
		seestate = S_NULL,
		seesound = sfx_None,
		reactiontime = 8,
		attacksound = sfx_None,
		painstate = S_NULL,
		painchance = 0,
		painsound = sfx_None,
		meleestate = S_NULL,
		missilestate = S_NULL,
		deathstate = S_NULL,
		xdeathstate = S_NULL,
		deathsound = sfx_None,
		speed = 8,
		radius = 32*FRACUNIT,
		height = 64*FRACUNIT,
		dispoffset = 1,
		mass = 100,
		damage = 0,
		activesound = sfx_None,
		flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_DONTENCOREMAP,
		raisestate = S_NULL
}

states[S_AFTERBURNERJAWZ_A] = {
	sprite = SPR_ABJZ,
	frame = A,
	tics = 1,
	action = nil,
	var1 = 0,
	var2 = 0,
	nextstate = S_AFTERBURNERJAWZ_B
}

states[S_AFTERBURNERJAWZ_B] = {
	sprite = SPR_ABJZ,
	frame = B,
	tics = 1,
	action = nil,
	var1 = 0,
	var2 = 0,
	nextstate = S_AFTERBURNERJAWZ_A
}


local max_afterburner_timer = 40 * TICRATE
local afterburner_use_cost = 2 * TICRATE
local afterburner_death_time = TICRATE

local function AfterburnerChaser(player)
	if not (player and player.mo and player.mo.valid) then return end
	
	local actor = player.mo
	
	if actor.tracer then
		if actor.tracer.health then
			local thrust_factor = FixedMul(4*FRACUNIT, mapobjectscale)
			P_Thrust(actor, R_PointToAngle2(actor.x, actor.y, actor.tracer.x, actor.tracer.y), thrust_factor)
			if actor.paragliding and actor.tracer.paragliding then
				local zangle = R_PointToAngle2(0, 0, R_PointToDist2(actor.x, actor.y, actor.tracer.x, actor.tracer.y), actor.tracer.z - actor.z)
				P_SetObjectMomZ(actor, FixedMul(sin(zangle),thrust_factor), true)
			end
		else
			actor.tracer = nil
		end
	end
end


addHook("PlayerThink",function(p)
	if leveltime == 0 then
		p.afterburner = nil
		if p.mo and p.mo.valid then
			p.mo.tracer = nil
		end
	end
	if p.kartstuff[k_itemtype] == xItemLib.func.findItemByNamespace("XITEM_AFTERBURNERJAWZ") and p.kartstuff[k_itemamount] and not p.afterburner then
		p.afterburner = {timer = max_afterburner_timer,
								used_timer = 0,
								hud_blink = false}
	end
	
	if p.afterburner and p.mo then
		if p.afterburner.timer < max_afterburner_timer then
			p.afterburner.timer = max($ - 1,0)
			
			--Homing Code
			local victim = K_FindJawzTarget(p.mo, p)
			if victim and P_CheckSight(p.mo, victim.mo) and 
			FixedInt(R_PointToDist2(p.mo.x,p.mo.y, victim.mo.x, victim.mo.y)) < 2500 and 
			victim.kartstuff[k_growshrinktimer] <= 0 and 
			(invincible.value or victim.kartstuff[k_invincibilitytimer] == 0) and
			((G_RaceGametype() and p.kartstuff[k_position] > victim.kartstuff[k_position]) or G_BattleGametype()) then
				if p.mo.tracer != victim.mo then
					S_StartSound(victim.mo, sfx_s3k89)
				end
				p.mo.tracer = victim.mo
				local reticle = P_SpawnMobj(victim.mo.x, victim.mo.y, victim.mo.z, MT_PLAYERRETICULE)
				reticle.target = victim.mo
				reticle.sprite = SPR_AJRT
				reticle.frame = (leveltime % 10) / 2
				if p.afterburner.used_timer then
					reticle.frame = $ + 5
				end
				reticle.color = p.skincolor
				if not S_SoundPlaying(p.mo, sfx_s3kbes) then
					S_StartSound(p.mo, sfx_s3kbes)
				end
			else
				p.mo.tracer = nil
			end
			
		end
		
		--Ticker for Using
		if p.afterburner.used_timer then
			p.afterburner.used_timer = max($-1, 0)
			AfterburnerChaser(p)
		end
		
		if p.afterburner.timer < max_afterburner_timer then
		--Conditions to weaken afterburner
			if not p.spinout_check and p.kartstuff[k_spinouttimer] then
				p.afterburner.timer = $ - (10 * TICRATE)
			end
		--Conditions to lose afterburner
			if p.kartstuff[k_itemamount] == 0 and p.afterburner then
				p.afterburner = nil
			end
		
			if p.afterburner.timer <= 0  or p.kartstuff[k_respawn] > 0 or p.playerstate == PST_DEAD or --Dead /  Timer Ran Out
			p.kartstuff[k_growshrinktimer] < 0 or p.kartstuff[k_eggmanexplode] or --Shrunk or Hit Eggbox
			p.kartstuff[k_squishedtimer] or p.kartstuff[k_stolentimer] then --Squished or Stolen
				p.kartstuff[k_itemamount] = $ - 1
				p.afterburner = nil
				p.mo.tracer = nil
			end
		end
		
		p.spinout_check = p.kartstuff[k_spinouttimer]
	end
end)

addHook("ThinkFrame", function()
	for p in players.iterate do
		if not p.afterburner then return end
		if not p.afterburner.used_timer then return end
		if not p.mo.tracer then return end
		p.mo.frame = Q
	end
end)

addHook("MobjMoveCollide", function(moving, not_moving)
	if moving.player and moving.player.afterburner and moving.player.afterburner.used_timer > 0 then
		if not_moving.player 
		and ((moving.z <= not_moving.z + not_moving.height) and (moving.z + moving.height >= not_moving.z))then
			moving.hf_overrideicon = "HF_ABJZ"
			K_SpinPlayer(not_moving.player, moving, 1, moving)
			moving.player.afterburner.timer = 0
			moving.player.mo.tracer = nil
		end
	end
end, MT_PLAYER)

-- if afterburner_targetinvincible is on, afterburner hurt invincible players
addHook("ShouldSpin", function(target, inflictor, source)
	if not invincible.value then return end
	if target.kartstuff[k_invincibilitytimer] > 0
	or (target.kartstuff[k_growshrinktimer] > 0 or (HugeQuest and target.hugequest.huge > 0))
	and inflictor.player.afterburner.used_timer > 0
	and target.mo == inflictor.player.mo.tracer then
		return true
	end
	
	return
end, MT_PLAYER)

--Afterburner Jawz Mobj Thinker
local rainbow = {24, 34, 35, 47, 38, 61, 63, 72, 74, 85, 86, 93, 98, 94}
addHook("MobjThinker", function(mobj)
	local p
	if mobj.target then
		p = mobj.target.player
	end
	
	if invincible.value then
		mobj.color = rainbow[((leveltime % (#rainbow*2))/2) + 1]
	else
		mobj.color = SKINCOLOR_JAWZ
	end

	if p and p.mo then
		local angle_offset = p.mo.angle + (mobj.extravalue1 * ANGLE_90)
		mobj.destscale = p.mo.scale
		//Homing Shenanigans
		if p.mo.tracer and (mobj.target and p == mobj.target.player) then
			mobj.angle = R_PointToAngle2(mobj.x, mobj.y, p.mo.tracer.x, p.mo.tracer.y)
			
			if p.afterburner.used_timer then
				mobj.colorized = true
				angle_offset = $ - (mobj.extravalue1 * ANGLE_45)
			else
				mobj.colorized = ((leveltime % 4 / 2) == 1)
			end
		else
			mobj.angle = p.mo.angle
			mobj.colorized = false
		end
		
		//General Shenanigans
		if p.afterburner then
			//Boostflame Control
			if p.afterburner.used_timer == 44 then
				if mobj.burner
					P_KillMobj(mobj.burner)
					mobj.burner = nil
				end

				if not mobj.burner
					mobj.burner = P_SpawnMobj(mobj.x, mobj.y, mobj.z, MT_ABJZBOOSTER)
					mobj.burner.target = mobj
				end
			end
			//Regular Movement
			local object_scale = FixedMul(mobj.scale, p.mo.scale)
			local new_x = FixedMul(56*cos(angle_offset), object_scale)
			local new_y = FixedMul(56*sin(angle_offset), object_scale)
			local new_z = (FRACUNIT * 8) + FixedMul(4*sin(leveltime*ANG1*4), object_scale)
			P_MoveOrigin(mobj, p.mo.x + new_x, p.mo.y + new_y, p.mo.z + new_z)
		else
			//Dropped Movement
			S_StartSound(mobj, mobj.info.deathsound)
			P_SetObjectMomZ(mobj, 8*FRACUNIT, false)
			P_InstaThrust(mobj, R_PointToAngle2(p.mo.x, p.mo.y, mobj.x, mobj.y)+(mobj.extravalue1*ANG60), 16*FRACUNIT)
			mobj.momx = $ + p.mo.momx
			mobj.momy = $ + p.mo.momy
			mobj.momz = $ + p.mo.momz
			mobj.target = nil
		end
	else
		A_SetObjectFlags(mobj, MF_NOGRAVITY, 1)
		A_SetObjectFlags2(mobj, MF2_DONTDRAW, 1 + leveltime % 2)
		mobj.angle = $ + (ANGLE_45 * leveltime)
		if P_IsObjectOnGround(mobj) then
			P_KillMobj(mobj)
		end
	end
end, MT_AFTERBURNER_JAWZ)

local function useAfterburner(p, cmd)
	if P_IsObjectOnGround(p.mo) or p.mo.paragliding then
		if p.afterburner then
			if p.afterburner.timer == max_afterburner_timer then
				p.afterburner.timer = $ - 1
				p.afterburner.hud_blink = true
				K_PlayBoostTaunt(p.mo)
				for i = 0,1 do
					local abjz = P_SpawnMobj(p.mo.x,p.mo.y,p.mo.z,MT_AFTERBURNER_JAWZ)
					abjz.target = p.mo
					abjz.scale = FRACUNIT / 24
					abjz.scalespeed = FRACUNIT / 16
					abjz.extravalue1 = (i * 2) - 1
					P_SpawnShadowMobj(abjz)
					S_StartSound(abjz, sfx_s3k3a)
				end
			else
				p.afterburner.timer = ($ - afterburner_use_cost)
				p.afterburner.used_timer = 45
				K_DoSneaker(p, 2)
			end
		end
	end
end

local function drawAfterburner(v,p,c)
	if p.afterburner.timer < max_afterburner_timer then
		p.xItemData.xItem_timerBar = p.afterburner.timer
		p.xItemData.xItem_maxTimerBar = max_afterburner_timer
	end
	if p.afterburner
		xItemLib.func.hudDrawItem(v, p, c, nil, (p.afterburner.hud_blink and 2) or nil)
	end
end
--item flags
local XIF_POWERITEM = 1 --is power item (affects final odds)
local XIF_COOLDOWNONSTART = 2 --can't be obtained on start cooldown
local XIF_UNIQUE = 4 --only one can exist in anyone's slot
local XIF_LOCKONUSE = 8 --locks the item slot when the item is used, slot must be unlocked manually by setting player.xItemData.xItem_itemSlotLocked to false
local XIF_COOLDOWNINDIRECT = 16 --checks if indirectitemcooldown is 0
local XIF_COLPATCH2PLAYER = 32 --map hud patch colour to player prefcolor
local XIF_ICONFORAMT = 64 --item icon changes depending on the item amount (animation frames become amount frames)
local XIF_SMUGGLECHECK = 128 --item contributes to the smuggle detection

if xItemLib then
	xItemLib.func.addItem{
		"XITEM_AFTERBURNERJAWZ", --Item Code
		"Afterburner Jawz", --Item Name
		"K_ITABJZ", --Big Graphic Name
		"K_ISABJZ", --Small Graphic Name
		XIF_POWERITEM|XIF_SMUGGLECHECK, --Flags
		{ 0, 0, 0, 0, 0, 0, 3, 5, 6, 0 }, --Race Odds
		{ 2, 4 }, --Battle Odds
		nil, --Item Recieved Function
		useAfterburner, --Item Used Function
		drawAfterburner, --Item Hud Function (For Animation in the Hud, I think)
		nil, --Item Odds Override
		nil, --Item Results Function
		{0, {SPR_ABJZ, C}}, --Dropped Item Frames
		true, --Show Up in Roulette?
		nil, --Preuse Function
		nil --Dropped Item Function
	}
	
	xItemLib.func.setXItemModData("XITEM_DESCRIPTIONS", "XITEM_AFTERBURNERJAWZ", {
		tipDescription1 = "Faster than a Rocket Sneaker, but watch out for the Jawz Targeting",
		tipDescription2 = "Get too close, and you become a Jawz",
		tipUsage1 = "Lasts longer than a Rocket Sneaker, so use it to your advantage",
		tipUsage2 = "Use it and swerve to use up all the boost, or bully players getting too close",
	})
end

-- ALL THE CODE UNDERNEATH HERE IS FOR BOOSTLIB...
-- THANK YOU RETROSTATION FOR DOING HACKY SHIT TO GET BOOSTLIB TO WORK ON THIS ITEM


local function AfterburnerChainFunc(p, name, t)
	if p.afterburner
	and t > p.afterburner.used_timer then
		p.afterburner.used_timer = t
	end
	
	return p.afterburner.used_timer
end

if BLib then
	BLib.RegisterChainFunc("Afterburner", AfterburnerChainFunc)
end

addHook("MobjThinker", function(mo)
	if not BLib then return end
	local mop = mo.player
	local mopks = mo.player.kartstuff
	
	if (mop.afterburner and mop.afterburner.used_timer) then
		mop.afterburner.used_timer = max(BLib.BoostChain(mop, "Afterburner",$), $)
	end

	if (mop.afterburner and mop.afterburner.used_timer)
	and mopks[k_itemtype] == xItemLib.xItemNamespaces["XITEM_AFTERBURNERJAWZ"] then
		BLib.SetBoost(mop, "Afterburner", FRACUNIT/2, 8*FRACUNIT, 0, true, true, true, true, true)
	else
		BLib.SetBoost(mop, "Afterburner")
	end

end, MT_PLAYER)

local function AB_Thinker(mo)
	if not (mo and mo.valid) then return end
	if not (mo.target and mo.target.valid) then 
		P_KillMobj(mo)
		return 
	end
	if not (mo.target.target and mo.target.target.valid and mo.target.target.player) then return end
	
	local p = mo.target.target.player

	mo.angle = mo.target.angle
	P_MoveOrigin(mo, mo.target.x + P_ReturnThrustX(mo, mo.angle+ANGLE_180, mo.target.radius), mo.target.y + P_ReturnThrustY(mo, mo.angle+ANGLE_180, mo.target.radius), mo.target.z)
	mo.scale = mo.target.scale
	
	if mo.state == S_BOOSTSMOKESPAWNER then
		local smoke = P_SpawnMobj(mo.x, mo.y, mo.z+(8<<FRACBITS), MT_BOOSTSMOKE)
		smoke.scale = mo.target.scale/2
		smoke.destscale = (3*mo.target.scale)/2
		smoke.scalespeed = mo.target.scale/12
		smoke.momx = mo.target.momx/2
		smoke.momy = mo.target.momy/2
		smoke.momz = mo.target.momz/2
		P_Thrust(smoke, mo.angle+FixedAngle(P_RandomRange(135, 225)<<FRACBITS), P_RandomRange(0, 8) * mo.target.scale)
	end
	
	if not (p.afterburner and p.afterburner.used_timer) then
		mo.target.burner = nil
		P_KillMobj(mo)
	end
end
addHook("MobjThinker", AB_Thinker, MT_ABJZBOOSTER)